/*
 * Copyright (C) 2009-2012 University of Freiburg
 *
 * This file is part of SMTInterpol.
 *
 * SMTInterpol is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * SMTInterpol is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with SMTInterpol.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.uni_freiburg.informatik.ultimate.smtinterpol.dpll;

/**
 * A per clause hook that is called whenever a clause it is registered for gets
 * removed from the clause database.
 * @author Juergen Christ
 */
public interface ClauseDeletionHook {
	/**
	 * Called once to notify about the deletion of this clause.
	 * @param c 		Clause that gets deleted.
	 * @param engine	Core DPLL solver.
	 * @return Can this clause be deleted?
	 */
	boolean clauseDeleted(Clause c, DPLLEngine engine);
}
